/* computes the determinate unfolding rule */
/* JPG: 10.7.90 */

resultant(A,R) :-
        resultant(A,_,R).

resultant(G,(P,Chs),B) :-
	ref_clause(G,B,N),
	no_Deadend(B),
	prefix(B,P1,R),
	my_append(P1,[N],P),
	choicelist(R,Chs).
	

choicelist(G,[var]) :-
	var(G),
	!.
choicelist((G,Gs),[Ch|Chs]) :-
	!,
	choice(G,Ch),
	choicelist(Gs,Chs).
choicelist(G,[Ch]) :-
	choice(G,Ch).


prefix(true,[],true) :-
	!.
prefix(Gs,[(N,C)|Ns],Gs1) :-
	det_eval(Gs,Gs2,N,C),
	!,
	prefix(Gs2,Ns,Gs1).
prefix(Gs,[],Gs).

det_eval(Gs,Gs1,N,C) :-
	select_lit(Gs,B,Gs3,N),
	choices(B,Ch,Gs3),
	Ch = [(C,(H :- R))], /* determinate */
	!,
	replace_goal(Gs,N,Gs1,H,R).


select_lit((G,Gs),G,Gs,1).
select_lit((B,Gs),G,(B,Gs1),N1) :-
        !,
        select_lit(Gs,G,Gs1,N),
        N1 is N+1.
select_lit(G,G,true,1).

replace_goal((G,true),2,G,_,_) :- /* eliminate true at end of goal */
	!.
replace_goal((G,Gs),1,Gs1,G,R) :-
	!,
	joingoals(R,Gs,Gs1).
replace_goal((G,Gs),N,(G,Gs1),H,R) :-
	!,
	N1 is N-1,
	replace_goal(Gs,N1,Gs1,H,R).
replace_goal(G,1,R,G,R).

choices(clause(G,B),Cs,Gs) :-
	!,
	bagof((N,(clause(G,B) :- true)),[Gs]^(ref_clause(G,B,N),no_Deadend(B),
		no_Deadend(Gs)),Cs).
choices(G,Ps,Gs) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(call(G),no_Deadend(Gs)), Ps).
choices(G,[],_) :-
	sp_builtin(G),
	!.
choices(G,[],_) :-
	imported(G),
	!.
choices(G,Ps,Gs) :-
	evaluable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(sp_solve(G),no_Deadend(Gs)), Ps).
choices(G,Cs,Gs) :-
	bagof((N,(G :- B)),
		[Gs]^(ref_clause(G,B,N),no_Deadend(B),no_Deadend(Gs)), Cs).

cleanup(_,X,X).
