/* IO utilities */


:- dynamic program_preds/1.
:- dynamic program_pred/2.
:- dynamic ub_clause/2.
:- dynamic directive/1.
:- import vars_instantiate/1 from system.
:- import write_clause/3 from system.

sp_builtin(X) :-
	builtin(X).

sp_writeClause( (Head :- Body), Bindings) :-
        ! ,
        ( vars_instantiate(Bindings) ,
                tellingptr(_out) ,
                write_clause(_out,Head,Body) , nl,
                fail
        ; true) .

sp_writeClause(Head, Bindings) :- sp_writeClause((Head:-true),Bindings) .


sp_writeClause(Clause):-
        varlist(Clause, Vars),
        createBindings(Vars, Bindings, 0),
        sp_writeClause(Clause, Bindings).

createBindings([], [], _).
createBindings([X | VarList], [XN = X | Bindings], N):-
        name('X', [C]),
        name(N, NN),
        name(XN, [C | NN]),
        N2 is N + 1,
        createBindings(VarList, Bindings, N2).

sp_writeRclause(Clause):-
	sp_writeClause(Clause).

new_line :-
	nl,
	write('      ').

getchar(C) :-
        get(Ch),
        name(C,[Ch]).

sp_ttyflush.

sp_ttynl :-
	write(stdout,'\n').

sp_length([],0).
sp_length([_|Xs],N) :-
	sp_length(Xs,N1),
	N is N1+1 .

end_of_file(end_of_file).	% for compatibility with Sicstus

ref_clause(G,B,N) :-
	rclause(ub_clause(G,B),true,N).

re_read(F) :-
	home_dir(D),
        concatstring(D,F,Fullpath),
        reconsult(Fullpath).

my_reconsult(F) :-
	home_dir(D),
        concatstring(D,F,Fullpath),
        reconsult(Fullpath).


directive(dummy).

bim_options :-
	please(readeoffail,off),
	please(readeofatom,end_of_file).

?- bim_options,
   ['~john/LP/APE/ape.pl','~john/LP/APE/utils.pl','~john/LP/APE/unfold_utils.pl',
   '~john/LP/APE/cleanup.pl',
    '~john/LP/APE/msv_detpath.pl',
    '~john/LP/APE/sp_main.pl',
    '~john/LP/APE/unf.pl',
    '~john/LP/APE/bim_consult.pl',
    '~john/LP/Types/tp_alpha_any.pl', '~john/LP/Types/ub_any.pl',
    '~john/LP/Types/is_any.pl','~john/LP/Types/subtype_any.pl',
%    '~john/LP/Types/tp_rul.pl', '~john/LP/Types/ub2.pl',
%    '~john/LP/Types/is2.pl','~john/LP/Types/subtype2.pl',
%    '~john/LP/Types/subtype_any.pl',
    '~john/LP/Types/dg3.pl',
    '~john/LP/APE/magic1.pl',
    '~john/LP/APE/reex_trans.pl',
    '~john/LP/Types/modelize.pl',
    '~john/LP/Types/rule2clause.pl',
    '~john/LP/Types/precision.pl',
    '~john/LP/APE/binary.pl'].
%	'sounds.pl'
