/* JPG: 1.9.91 */
/* determinate unfolding with user-controlled unfolding choices */

resultant(catom(G, C),(Point,Cont),R) :-
	G = byte(_,_,_,_,[p(Point,_)|_],Stack),
	(Stack=[Cont|_]; Stack=[],Cont=[]),
	!,
	constraints(C),
	ref_clause(G,B),
	ref_clause(B,B1),
	derivation(B1,R),
	no_Deadend(R).
resultant(catom(G,C),P,R) :-
	constraints(C),
	ref_clause(G,B),
	derivation(B,R),
	no_Deadend(R),
	arg(1,G,P).
	
pp(byte(_,_,_,_,_,_)) :- !.
pp(G) :- write(G),  nl, ttyflush.

/* Determinate unfolding only */

derivation(true,true) :-
	!.
derivation(Gs,Gs1) :-
	derivation_step(Gs,Gs2,Suspend),
	no_Deadend(Gs2),
	derivation_continue(Suspend,Gs2,Gs1).

derivation_continue(yes,Gs,Gs).
derivation_continue(no,Gs2,Gs1) :-
	derivation(Gs2,Gs1).
	

derivation_step((\+G,Gs),Gs,no) :-
	unfoldable(\+G),
	!,
	\+ sp_solve(G).
derivation_step((B,Gs),Gs,no) :-
	sp_builtin(B),
	unfoldable(B),
	!,
	call(B).
derivation_step((B,Gs),(B,Gs1),Susp) :-
	sp_builtin(B),
	!,
	derivation_step(Gs,Gs1,Susp).
derivation_step((B,Gs),(B,Gs1),Susp) :-
	suspend_goal(B),
	!,
	derivation_step(Gs,Gs1,Susp).
derivation_step((B,Gs),(B,Gs1),Susp) :-
	nondeterminate(B),
	pp(B),
	!,
	derivation_step(Gs,Gs1,Susp).
derivation_step((B,Gs),Gs1,no) :-
	!,
	ref_clause(B,R),
	joingoals(R,Gs,Gs1).
derivation_step(\+B,true,no) :-
	unfoldable(\+B),
	!,
	\+ sp_solve(B).
derivation_step(B,true,no) :-
	sp_builtin(B),
	B \== true,
	unfoldable(B),
	!,
	call(B).
derivation_step(B,B,yes) :-
	sp_builtin(B),
	!.
derivation_step(B,B,yes) :-
	suspend_goal(B),
	!.
derivation_step(B,B,yes) :-
	nondeterminate(B),
	!.
derivation_step(B,R,no) :-
	ref_clause(B,R).


suspend_goal(byte(_,_,_,_,[P|_],_)) :-
	nonvar(P),
	P = p(_,_).

nondeterminate(G) :-
	bagof(B, G^(
		ref_clause(G,B),
		no_Deadend(B)),[_,_|_]).

select_lit((G,_),G,1).
select_lit((_,Gs),G,N1) :-
	!,
	select_lit(Gs,G,N),
	N1 is N+1.
select_lit(G,G,1).

replace_goal((G,true),2,G,_,_) :- /* eliminate true at end of goal */
	!.
replace_goal((G,Gs),1,Gs1,G,R) :-
	!,
	joingoals(R,Gs,Gs1).
replace_goal((G,Gs),N,(G,Gs1),H,R) :-
	!,
	N1 is N-1,
	replace_goal(Gs,N1,Gs1,H,R).
replace_goal(G,1,R,G,R).

constraintgoal(_ > _).
constraintgoal(_ < _).
constraintgoal(_ >= _).
constraintgoal(_ =< _).
constraintgoal(_ = _).
constraintgoal(_ =:= _).
constraintgoal(_ is _).
constraintgoal(_ =\= _).
constraintgoal({_}).
