% add an extra argument to each predicate, and add a unique identifier
% to each body literal

add_indices(F,F1,Q) :-
	tell(F1),
	add_index_clauses(F,1,_),
	told.

add_index_clauses(F,N,M) :-
	see(F),
	read(C),
	index_clauses(C,N,M),
	seen.

index_clauses(X,N,N) :- 
	end_of_file(X),
	!.
index_clauses((:- op(X,Y,Z)),N,M) :- 
	!,
	write(':- '),
	write(op(X,Y,Z)),
	write('.'),
	nl,
	read(C1),
	!,
	index_clauses(C1,N,M).
index_clauses((:- ),N,M) :- 
	!,
	read(C1),
	!,
	index_clauses(C1,N,M).
index_clauses((A :- B),N,N2) :- 
	!,
	indexed_lits(B,Bs,N,N1),
	indexed_head(A,AA),
	canonical((AA :- Bs)),
	displayqRClauses([(AA :- Bs)]),
	read(C1),
	!,
	index_clauses(C1,N1,N2).
index_clauses(A,N,M) :- 
	indexed_head(A,AA),
        canonical((AA :- true)),
        displayqRClauses([(AA :- true)]),
	read(C1),
	!,
	index_clauses(C1,N,M).

indexed_lits((B,Bs),(B,Bs1),N,M) :-
	sp_builtin(B),
	!,
	indexed_lits(Bs,Bs1,N,M).
indexed_lits((B,Bs),(B1,Bs1),N,M) :-
	!,
	B =.. [P|Xs],
	B1 =.. [P,N|Xs],
	N1 is N+1,
	indexed_lits(Bs,Bs1,N1,M).
indexed_lits(B,B,N,N) :-
	sp_builtin(B).
indexed_lits(B,B1,N,N1) :-
	N1 is N+1,
	B =.. [P|Xs],
        B1 =.. [P,N|Xs].

indexed_head(B,B1) :-
	B =.. [P|Xs],
        B1 =.. [P,_|Xs].
