
% mgu(T1,T2,S):  S is a (relevant) mgu for T1 and T2

mgu(T1,T2,Bs) :-
	vars((T1,T2),Xs),
	copyterm((T1,T2,Xs),(U,U,Ws)),  % unify a copy of T1 and T2
	relevant(Xs,Ws),
	bindings(Xs,Ws,[],Bs).

relevant([],[]).
relevant([X|Xs],[V|Vs]) :-
	var(V),
	\+ memb3(V,Vs),	
	!,
	X=V,
	relevant(Xs,Vs).
relevant([_|Xs],[_|Vs]) :-
	relevant(Xs,Vs).

bindings([X|Xs],[T|Ts],Bs,Bs1) :-
	X \== T,
	bindings(Xs,Ts,[X=T|Bs],Bs1).
bindings([X|Xs],[T|Ts],Bs,Bs1) :-
	X == T,
	bindings(Xs,Ts,Bs,Bs1).
bindings([],[],Bs,Bs).
 
