/* JPG: 1.9.91 */
/* determinate unfolding with more specific clause transforms */




resultant(A,R) :-
	resultant(A,_,[],R).

resultant(A,Path,R) :-
	resultant(A,Path,[],R).


%resultant(G,[N|P],P3,R2) :-
resultant(G,[N|P],P3,R1) :-
	ref_clause(G,B,N),
	more_specific(B),
	prefix(B,P,P2,R,Det),
	repeat_msv_prefix(R,P2,P3,R1,Det),
	more_specific(R1),
	no_Deadend(R1).
%	unfold_choice(R1,R2),
%	more_specific(R2),
%	no_Deadend(R2).
	

repeat_msv_prefix(R,P,P,R,nondet) :-
	!.
repeat_msv_prefix(R,P1,P3,R1,det) :-
	more_specific(R),
	prefix(R,P1,P2,R2,Det),
	repeat_msv_prefix(R2,P2,P3,R1,Det).

more_specific(B) :-
	var(B),
	!.
more_specific(X=X) :-
	!.
more_specific((B,Bs)) :-
	!,
	more_specific(B),
	more_specific(Bs).
more_specific(B) :-
        solve_choice(B,_).

/*
choicelist(G,[var]) :-
	var(G),
	!.
choicelist((G,Gs),[Ch|Chs]) :-
	!,
	choice(G,Ch),
	choicelist(Gs,Chs).
choicelist(G,[Ch]) :-
	choice(G,Ch).
*/

/* Determinate unfolding only */

prefix(true,Ns,Ns,true,_) :-
	!.
prefix(Gs,Ns,Ns1,Gs1,det) :-
	select_lit(Gs,B,Gs3,N),
	choices(B,Ch,Gs3),
	Ch=[(C,(H :- R))],
	!,
	replace_goal(Gs,N,Gs2,H,R),
	prefix(Gs2,Ns,[(N,C)|Ns1],Gs1,det).
prefix(Gs,Ns,Ns,Gs,_) :-
	no_Deadend(Gs).

select_lit((G,Gs),G,Gs,1).
select_lit((B,Gs),G,(B,Gs1),N1) :-
	!,
	select_lit(Gs,G,Gs1,N),
	N1 is N+1.
select_lit(G,G,true,1).

replace_goal((G,true),2,G,_,_) :- /* eliminate true at end of goal */
	!.
replace_goal((G,Gs),1,Gs1,G,R) :-
	!,
	joingoals(R,Gs,Gs1).
replace_goal((G,Gs),N,(G,Gs1),H,R) :-
	!,
	N1 is N-1,
	replace_goal(Gs,N1,Gs1,H,R).
replace_goal(G,1,R,G,R).


choices(clause(G,B),Cs,Gs) :-
	!,
	bagof((N,(clause(G,B) :- true)),
		[Gs]^(ref_clause(G,B,N),no_Deadend(B),
		no_Deadend(Gs)),Cs).
choices(G,Ps,Gs) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(sp_solve(G),no_Deadend(Gs)), Ps).
choices(G,[],_) :-
	sp_builtin(G),
	!.
choices(G,[],_) :-
	imported(G),
	!.
choices(G,Ps,Gs) :-
	evaluable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(sp_solve(G),no_Deadend(Gs)), Ps).
choices(G,Cs,Gs) :-
	bagof((N,(G :- B)),
		[Gs]^(ref_clause(G,B,N),no_Deadend(B),no_Deadend(Gs)), Cs).
