% Reexecution transformation: 
% JPG: 11.10.93
%
% reex(F,F1): reex(+,+)
%
%	F = source file
%	F1 = file for writing transformed program
%
%
% if using with BIM, execute the query ?- bim_options.  first.
% if using with Sicstus, un-comment the last clause(s).  See comments
% at end of program.


reex(F,F1) :-
	see(F),
	tell(F1),
	read(C),
	orig_clauses(C),
	seen,
	see(F),
	read(C1),
	reex_clauses(C1),
	seen,
	nl,
	told.

orig_clauses(X) :- 
	end_of_file(X),
	!.
orig_clauses((A :- B)) :- 
	!,
	canonical((A :- B)),
	displayqClauses([(A :- B)]),
	read(C1),
	!,
	orig_clauses(C1).
orig_clauses(A) :- 
        canonical(A),
        displayqClauses([(A :- true)]),
	read(C1),
	!,
	orig_clauses(C1).

reex_clauses(X) :-
        end_of_file(X),
        !.
reex_clauses((A :- B)) :-
        !,
        reex_lits(B,Bs,true),
	flat_names(Bs,R),
	joingoals(B,R,G),
	flat_name(reex(A),AA),
        canonical((AA :- G)),
        displayqClauses([(AA :- G)]),
        read(C1),
        !,
        reex_clauses(C1).
reex_clauses(A) :-
	flat_name(reex(A),AA),
        canonical((AA :- true)),
        displayqClauses([(AA :- true)]),
        read(C1),
        !,
        reex_clauses(C1).


reex_lits(true,C,C) :-
	!.
reex_lits((B,Bs),C,D) :-
	sp_builtin(B),
	!,
	reex_lits(Bs,C,(B,D)).
reex_lits((B,Bs),C,D) :-
	!,
	reex_lits(Bs,C,(reex(B),D)).
reex_lits(B,(B,C),C) :-
	sp_builtin(B).
reex_lits(B,(reex(B),C),C).

/*
flat_name(A,A) :-
	sp_builtin(A),
	!.
flat_name(A,A1) :-
	A =.. [F,As],
	As =.. [G|Args],
	name(F,Fn),
	name(G,Gn),
	concat(Fn,[95|Gn],An),
	name(H,An),
	A1 =.. [H|Args].

flat_name(true,true) :-
	!.
flat_names((B,Bs),(B1,Bs1)) :-
	!,
	flat_name(B,B1),
	flat_names(Bs,Bs1).
flat_names(B,B1) :-
	flat_name(B,B1).

*/
