reex_clauses(X) :- 
	end_of_file(X),
	!.
reex_clauses((A :- B)) :- 
	!,
	reexlits(B,Bs),
	flat_name(reex(A),AA),
	flat_name(context(A),QA),
	flat_names(Bs,FBs),
	canonical((AA :- QA,FBs)),
	displayqClauses([(AA :- QA,FBs)]),
	read(C1),
	!,
	reex_clauses(C1).
reex_clauses(A) :- 
	flat_name(reex(A),AA),
        flat_name(context(A),QA),
        canonical((AA :- QA)),
        displayqClauses([(AA :- QA)]),
	read(C1),
	!,
	reex_clauses(C1).

reex_ans_clauses(X) :- 
	end_of_file(X),
	!.
reex_ans_clauses((A :- B)) :- 
%	B = (_,_),
	!,
	reexlits(B,Bs),
	flat_names(Bs,FBs),
	canonical((A :-FBs)),
	displayqClauses([(A :- FBs)]),
	read(C1),
	!,
	reex_ans_clauses(C1).
%reex_ans_clauses((A :- B)) :- 
%	!,
%        canonical((A :- B)),
%        displayqClauses([(A :- B)]),
%	read(C1),
%	!,
%	reex_ans_clauses(C1).
reex_ans_clauses(A) :- 
        canonical(A),
        displayqClauses([(A :- true)]),
	read(C1),
	!,
	reex_ans_clauses(C1).

reexlits((B,Bs),(B,Bs1)) :-
	sp_builtin(B),
	!,
	reexlits(Bs,Bs1).
reexlits((B,Bs),(reex(B),Bs1)) :-
	!,
	reexlits(Bs,Bs1).
reexlits(B,B) :-
	sp_builtin(B).
reexlits(B,reex(B)).

/*
flat_name(A,A) :-
	sp_builtin(A),
	!.
flat_name(A,A1) :-
	A =.. [F,As],
	As =.. [G|Args],
	name(F,Fn),
	name(G,Gn),
	concat(Gn,[95|Fn],An),
	name(H,An),
	A1 =.. [H|Args].

flat_names((B,Bs),(B1,Bs1)) :-
	!,
	flat_name(B,B1),
	flat_names(Bs,Bs1).
flat_names(B,B1) :-
	flat_name(B,B1).

*/
reex(F,F1) :-
	see(F),
	tell(F1),
	read(C),
	reex_ans_clauses(C),
	seen,
	see(F),
	read(C),
	reex_clauses(C),
	seen,
	see(F),
	read(C1),
	context_clauses(C1),
	seen,
	told.


context_clauses(Z) :- 
	end_of_file(Z),
	!.
context_clauses((A :- B)) :- 
	!,
	canonical((A,B)),
	bodylitcontexts(A,true,B),
	read(C1),
	!,
	context_clauses(C1).
context_clauses(_) :- 
	read(C1),
	!,
	context_clauses(C1).

bodylitcontexts(_,_,true) :-
	!.
bodylitcontexts(A,B,(Bj,Bs)) :-
	sp_builtin(Bj),
	!,
	bodylitcontexts(A,B,Bs).
bodylitcontexts(A,B,(Bj,Bs)) :-
	!,
	joingoals(B,Bs,Bs1),
	flat_name(context(Bj),QBj),
	flat_name(context(A),QA),
	%displayqClauses([(QBj :- Bs1)]),
	displayqClauses([(QBj :- QA,Bs1)]),
	joingoals(B,Bj,Bsj),
	bodylitcontexts(A,Bsj,Bs).
bodylitcontexts(A,true,Bj) :-
	!,
        flat_name(context(Bj),QBj),
        flat_name(context(A),QA),
        displayqClauses([(QBj :- QA)]).
bodylitcontexts(A,Bs1,Bj) :-
	!,
        flat_name(context(Bj),QBj),
        flat_name(context(A),QA),
        %displayqClauses([(QBj :- Bs1)]),
        displayqClauses([(QBj :- QA,Bs1)]).

