/* determinate unfolding with user-controlled unfolding choices */

resultant(catom(G,C),P,(R,U1,C),K0) :-
	rul_constraints(G,C,U),
	ref_clause(G,B),
	derivation(B,R),
	no_Deadend(R),
	unfold_body(U,C,U1),
	non_empty_rul(U1,C,K0),
	arg(1,G,P).	% return the trace term
	
rul_constraints(G,[proc(_,[(_ :- B)])|_],U) :-
	G =.. [_|Args],
	unary_constraints(Args,B,U).

non_empty_rul(U1,C,K0) :-
	intersect_body(U1,C,_,_,K0,_).

unary_constraints([],true,true).
unary_constraints([A],B,U) :-
	functor(B,T,1),
	U =.. [T,A].
unary_constraints([A1,A2|As],(B,Bs),(U,Us)) :-
	functor(B,T,1),
	U =.. [T,A1],
	unary_constraints([A2|As],Bs,Us).
	
/* Determinate unfolding only */

derivation(true,true) :-
	!.
derivation(Gs,Gs1) :-
	derivation_step(Gs,Gs2,true,Suspend),
	no_Deadend(Gs2),
	derivation_continue(Suspend,Gs2,Gs1).

derivation_continue(yes,Gs,Gs).
derivation_continue(no,Gs2,Gs1) :-
	derivation(Gs2,Gs1).
	
derivation_step((\+G,Gs),Gs,_,no) :-
	unfoldable(\+G),
	!,
	\+ sp_solve(G).
derivation_step((B,Gs),Gs,_,no) :-
	sp_builtin(B),
	unfoldable(B),
	!,
	call(B).
derivation_step((B,Gs),(B,Gs1),Hs,Susp) :-
	sp_builtin(B),
	!,
	derivation_step(Gs,Gs1,(B,Hs),Susp).
derivation_step((B,Gs),(B,Gs1),Hs,Susp) :-
	suspend_goal((B,Gs)),
	!,
	derivation_step(Gs,Gs1,(B,Hs),Susp).
derivation_step((B,Gs),Gs1,_,no) :-
	!,
	ref_clause(B,R),
	joingoals(R,Gs,Gs1).
derivation_step(\+B,true,_,no) :-
	unfoldable(\+B),
	!,
	\+ sp_solve(B).
derivation_step(B,true,_,no) :-
	sp_builtin(B),
	B \== true,
	unfoldable(B),
	!,
	call(B).
derivation_step(B,B,_,yes) :-
	sp_builtin(B),
	!.
derivation_step(B,B,Hs,yes) :-
	suspend_goal((B,Hs)),
	!.
derivation_step(B,R,_,no) :-
	ref_clause(B,R).

% user defined suspend conditions, if any, go here

suspend_goal(B) :-
	nondeterminate(B).

nondeterminate((G,Gs)) :-
	!,
	bagof(Bs, (G,Gs,B)^(
		ref_clause(G,B),
		joingoals(B,Gs,Bs),
		no_Deadend(Bs)),[_,_|_]).
nondeterminate(G) :-
	bagof(B, G^(
		ref_clause(G,B),
		no_Deadend(B)),[_,_|_]).

select_lit((G,_),G,1).
select_lit((_,Gs),G,N1) :-
	!,
	select_lit(Gs,G,N),
	N1 is N+1.
select_lit(G,G,1).


