/* JPG: 1.9.91 */
/* determinate unfolding with user-controlled unfolding choices */

resultant(A,R) :-
	resultant(A,_,R).

resultant(G,[N|P10],R) :-
	ref_clause(G,B,N),
	prefix(B,P,R),
	truncate(P,10,P10).
%resultant(G,F/N,R) :-
%	functor(G,F,N),
%	ref_clause(G,B,_),
%	prefix(B,_,R).
%resultant(G,J,R) :-
%	G =.. [_,J|_],
%	ref_clause(G,B,_),
%	prefix(B,_,R).
	
truncate([],_,[]).
truncate([X|_],1,[X]).
truncate([X|Xs],N,[X|Ys]) :-
	N > 1,
	N1 is N-1,
	truncate(Xs,N1,Ys).

/* Determinate unfolding only */

prefix(true,[],true) :-
	!.
prefix(Gs,[(N,C)|Ns],Gs1) :-
	unfold_choice(Gs,N,C,Gs2),
	prefix(Gs2,Ns,Gs1).
prefix(Gs,[],Gs) :-
	\+ unfold_choice(Gs,_,_,_).

unfold_choice(Gs,N,C,Gs2) :-
	safe_select(Gs,B,N),
	sp_builtin(B),
	unfoldable(B),
	!,
	call(B),
	pattern(B,C),
	replace_goal(Gs,N,Gs2,B,true),
	no_Deadend(Gs2).
unfold_choice(Gs,N,C,Gs2) :-
	safe_select(Gs,B,N),
	unf(B),
	\+ imported(B),
	!,
	ref_clause(B,R,C),
	replace_goal(Gs,N,Gs2,B,R),
	no_Deadend(Gs2).
unfold_choice(Gs,N,C,Gs2) :-
	safe_select(Gs,B,N),
	evaluable(B),
	!,
	sp_solve(B),
	pattern(B,C),
	replace_goal(Gs,N,Gs2,B,true),
	no_Deadend(Gs2).

safe_select((G,_),G,1).
safe_select((B,Gs),G,N1) :-
	sp_builtin(B),
	!,
	safe_select(Gs,G,N),
	N1 is N+1.
%safe_select(G,G,1).

replace_goal((G,true),2,G,_,_) :- /* eliminate true at end of goal */
	!.
replace_goal((G,Gs),1,Gs1,G,R) :-
	!,
	joingoals(R,Gs,Gs1).
replace_goal((G,Gs),N,(G,Gs1),H,R) :-
	!,
	N1 is N-1,
	replace_goal(Gs,N1,Gs1,H,R).
replace_goal(G,1,R,G,R).

/*

choices(clause(G,B),Cs,Gs) :-
	!,
	bagof((N,(clause(G,B) :- true)),[Gs]^(ref_clause(G,B,N),
		no_Deadend(Gs)),Cs).
choices(G,Ps,Gs) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(call(G)), Ps).
choices(G,[],_) :-
	sp_builtin(G),
	!.
choices(G,[],_) :-
	imported(G),
	!.
choices(G,Ps,Gs) :-
	evaluable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(sp_solve(G)), Ps).
choices(G,Cs,Gs) :-
	bagof((N,(G :- B)),
		[Gs]^(ref_clause(G,B,N)), Cs).

*/
choices(clause(G,B),Cs,Gs) :-
	!,
	bagof((N,(clause(G,B) :- true)),
		[Gs]^(ref_clause(G,B,N),no_Deadend(B),
		no_Deadend(Gs)),Cs).
choices(G,Ps,Gs) :-
	sp_builtin(G),
	unfoldable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(call(G),no_Deadend(Gs)), Ps).
choices(G,[],_) :-
	sp_builtin(G),
	!.
choices(G,[],_) :-
	imported(G),
	!.
choices(G,Ps,Gs) :-
	evaluable(G),
	!,
	pattern(G,P),
	bagof((P,(G :- true)),[Gs]^(sp_solve(G),no_Deadend(Gs)), Ps).
choices(G,Cs,Gs) :-
	bagof((N,(G :- B)),
		[Gs]^(ref_clause(G,B,N),
		no_Deadend(B),no_Deadend(Gs)), Cs).
