/* User interface to program analysis and transformation tools */
/* JPG: 20.12.90  */
/* JPG: 27.3.92   */
/* JPG:  many subsequent changes.... */



sp :- home_dir(D),
	concatstring(D,'APE',D1),
	working_directory(_,D1),
	menu1.

prolog_select :-
	write('Which Prolog System ([b]im, [s]icstus)? '),
	read(P),
	prolog_select_choice(P).

prolog_select_choice(b) :-
	!,
        reconsult('~john/LP/APE/bim_specific.pl').
prolog_select_choice(s) :-
	!,
        reconsult('~john/LP/APE/sicstus_specific.pl').
prolog_select_choice(_) :-
	nl,
	write('Try again'),
	nl,
	!,
	prolog_select.

approx([]) :-
	!,
	program_preds(P),
	tp_fix(P).
approx(Ps) :-
	tp_fix(Ps).

binary_prog :-
        new_line,
        write('From File: '),
        read(F1),
        new_line,
        write('To File: '),
        read(F2),
        binary(F1,F2),
        menu1.
modelize_prog :-
        new_line,
        write('From File: '),
        read(F1),
        new_line,
        write('To File: '),
        read(F2),
        m(F1,F2),
        menu1.
rewrite_rule_prog :-
        new_line,
        write('From File: '),
        read(F1),
        new_line,
        write('To File: '),
        read(F2),
        r2c(F1,F2),
        menu1.
traceterm_prog :-
        new_line,
        write('From File: '),
        read(F1),
        new_line,
        write('To File: '),
        read(F2),
        traceterm_transform(F1,F2),
        menu1.
reex_prog :-
        new_line,
        write('From File: '),
        read(F1),
        new_line,
        write('To File: '),
        read(F2),
        reex(F1,F2),
        menu1.



	

welcome :-
	nl,write('      '),nl,write('      '),
	write('*****************'),nl,write('      '),
	write('* SP main menu  *'),nl,write('      '),
	write('*****************'),nl,write('      ').

menu1 :-
	welcome,
	write('1.  Read program.'),new_line,
	write('2.  Specialisation.'),new_line,
	write('3.  Query-Answer Analysis.'),new_line,
	write('4.  Bottom-Up Abstract Interpretation.'),new_line,
	write('5.  Select Unfolding Strategy.'),new_line,
	write('6.  Select Analysis Method.'),new_line,
	write('7.  Query-Answer Transform Options.'),new_line,
	write('8.  Transform to Binary Clause Form.'),new_line,
	write('9.  Transform to Model Form.'),new_line,
	write('A.  Transform Rewrite Rules.'),new_line,
	write('B.  Introduce Trace Terms.'),new_line,
	write('C.  Specialisation with Regular Approximation.'),new_line,
	write('D.  Specialisation with Regular Answers.'),new_line,
	new_line,
	get_sp_choice.

get_sp_choice :-
	write('Choice (0 to exit): '),
	getchar(C),
	select_sp(C),
	!.

select_sp(0) :- 
	!,
	new_line,
	write('Bye'),
	new_line.
select_sp(1) :-
	!,
	read_prog.
select_sp(2) :-
	!,
	sp_menu.
select_sp(3) :-
	!,
	magic_prog.
select_sp(4) :-
	!,
	approx_prog.
select_sp(5) :-
	!,
	unfold_menu.
select_sp(6) :-
	!,
	analysis_menu.
select_sp(7) :-
	!,
	magic_menu.
select_sp(8) :-
	!,
	binary_prog.
select_sp(9) :-
	!,
	modelize_prog.
select_sp('A') :-
	!,
	rewrite_rule_prog.
select_sp('B') :-
	!,
	traceterm_prog.
select_sp('C') :-
	!,
	re_read('APE/sp_main_rul'),
	re_read('APE/sprul'),
	re_read('APE/rul_ub'),
	re_read('APE/while_resultant'),
	menu1.
select_sp('D') :-
	!,
	re_read('APE/sp_main_callans'),
	re_read('APE/sp_callans_v2'),
	re_read('APE/rul_ub'),
	re_read('APE/while_resultant'),
	%re_read('APE/tt_resultant'),
	menu1.
	
%select_sp(9) :-
%	!,
%	reex_prog.
select_sp(_) :-
	write('Try again'),
	nl,new_line,
	get_sp_choice.

unfold_menu :-
	new_line,
	write('1. Determinate with more specific transformation.'),
	new_line,
	write('2. Determinate with path abstraction.'),new_line,
	write('3. No unfolding, alpha abstraction.'),new_line,
	write('4. No unfolding, beta abstraction.'),new_line,
	write('5. Determinate with no abstraction.'),new_line,
	write('6. First choicepoint with path abstraction.'),new_line,
	write('7. Determinate with optional unfolding.'),new_line,
	write('8. Like 7 but with more abstraction.'),new_line,
	write('9. Safe unfolding with cuts.'),new_line,
	write('a. Unfolding for ROPE.'),new_line,
	write('b. Bern''s global termination method.'),new_line,
	new_line,
	get_unfold_choice.
	
get_unfold_choice :-
	write('Choice (0 for previous level): '),
	getchar(C),
	select_unfold(C),
	!.

select_unfold(0) :-
	!,
	new_line,
	menu1.
select_unfold(1) :-
	!,
	new_line,
	re_read('APE/msv_detpath.pl'),
	new_line,
	menu1.
select_unfold(2) :-
	!,
	new_line,
	re_read('APE/detpath.pl'),
	new_line,
	menu1.
select_unfold(3) :-
	!,
	new_line,
	re_read('APE/alpha.pl'),
	re_read('APE/dupstruct.pl'),
	new_line,
	menu1.
select_unfold(4) :-
	!,
	new_line,
	re_read('APE/beta.pl'),
	re_read('APE/dupstruct.pl'),
	new_line,
	menu1.
select_unfold(5) :-
	!,
	new_line,
	re_read('APE/detpath_alpha.pl'),
	new_line,
	menu1.
select_unfold(6) :-
	!,
	new_line,
	re_read('APE/choicepoint.pl'),
	new_line,
	menu1.
select_unfold(7) :-
	!,
	new_line,
	re_read('APE/detpath_unf.pl'),
	new_line,
	menu1.
select_unfold(8) :-
	!,
	new_line,
	re_read('APE/detpath_unf1.pl'),
	new_line,
	menu1.
select_unfold(9) :-
	!,
	new_line,
	re_read('APE/cut_detpath.pl'),
	% re_read('APE/cut_cleanup.pl'),
	new_line,
	menu1.
select_unfold(a) :-
	!,
	new_line,
	re_read('APE/rope_path.pl'),
	new_line,
	unfold_menu.
select_unfold(b) :-
	!,
	new_line,
	re_read('APE/bernape.pl'),
	re_read('APE/detpath_unf_bound.pl'),
	re_read('APE/bern_sp_main.pl'),
	new_line,
	unfold_menu.
select_unfold(_) :-
	write('Invalid choice'),
	nl,new_line,
	get_unfold_choice.

	
read_prog :-
	new_line,
	write('File Name: '),
	read(F),
	sp_consult(F),
	!,
	menu1.

sp_menu :-
	new_line,
	write('Atomic goal: '),
	read(G),
	sp(G),
	% rooster,
	!,
	menu1.

approx_prog :-
	new_line,
	write('List of Predicates ([] = all): '),
	read(Ps),
	approx(Ps),
	!,
	menu1.

analysis_menu :-
        new_line,
        write('1. Regular Approximation (default).'),
        new_line,
        write('2. Prop Sharing Abstraction.'),
        new_line,
        write('3. T_p.'),
        new_line,
        write('4. Ground-any modes.'),
        new_line,
        write('5. Regular Approximation with basic types'),
        new_line,
        write('6. Polymorphic Type Inference'),
        new_line,
        write('7. T_p with msg abstraction'),
        new_line,
        write('8. Regular Approximation with named types'),
        new_line,
	new_line,
        get_analysis_choice.

get_analysis_choice :-
        write('Choice (0 for previous level): '),
        getchar(C),
        select_analysis(C),
        !.

select_analysis(0) :-
        !,
        new_line,
        menu1.

select_analysis(1) :-
        !,
	my_reconsult('Types/tp_alpha_any.pl'),
	my_reconsult('Types/subtype_any.pl'),
	my_reconsult('Types/ub_any.pl'),
	my_reconsult('Types/is_any.pl'),
        menu1.
select_analysis(2) :-
        !,
	my_reconsult('Sharing/tp_prop.pl'),
        menu1.
select_analysis(3) :-
        !,
	my_reconsult('Sharing/tp.pl'),
        menu1.
select_analysis(4) :-
        !,
	my_reconsult('Modes/tp_modes.pl'),
        menu1.
select_analysis(5) :-
        !,
	my_reconsult('Types/tp_alpha.pl'),
	my_reconsult('Types/subtype.pl'),
	my_reconsult('Types/ub.pl'),
	my_reconsult('Types/is.pl'),
        menu1.
select_analysis(6) :-
        !,
	my_reconsult('Types/tp_poly.pl'),
	my_reconsult('Types/subtype.pl'),
	my_reconsult('Types/ub.pl'),
	my_reconsult('Types/is.pl'),
	my_reconsult('Types/rewrite.pl'),
        menu1.
select_analysis(7) :-
        !,
	my_reconsult('Sharing/tpmsg.pl'),
        menu1.
select_analysis(8) :-
        !,
	my_reconsult('Types/tp_rul.pl'),
	my_reconsult('Types/subtype2.pl'),
	my_reconsult('Types/ub2.pl'),
	my_reconsult('Types/is2.pl'),
        menu1.
select_analysis(_) :-
	write('Invalid choice'),
	nl,new_line,
	get_analysis_choice.

magic_menu :-
        new_line,
        write('1. Query-answer transform (left)'),new_line,
        write('2. Query-answer transform (right)'),new_line,
        write('3. Query-answer transform (left+right)'),new_line,
        write('4. Simple query-answer transform'), new_line,
        write('5. Index query-answer transform (left)'),new_line,
        write('6. Q-A transform (dependency ordering)'),new_line,
        write('7. Q-A transform (dependency ordering + b-up answers)'),
	new_line,
        new_line,
        get_magic_choice.

get_magic_choice :-
        write('Choice (0 for previous level): '),
        getchar(C),
        select_magic(C),
        !.

select_magic(0) :-
        !,
        new_line,
        menu1.

select_magic(1) :-
        !,
        my_reconsult('APE/magic1.pl'),
        menu1.
select_magic(2) :-
        !,
        my_reconsult('APE/magic1_right.pl'),
        menu1.
select_magic(3) :-
        !,
        my_reconsult('APE/contextmagic.pl'),
        menu1.
select_magic(4) :-
        !,
        my_reconsult('APE/magic.pl'),
        menu1.
select_magic(5) :-
        !,
        my_reconsult('APE/indexmagic.pl'),
        menu1.
select_magic(6) :-
        !,
        my_reconsult('APE/dep_magic.pl'),
        menu1.
select_magic(7) :-
        !,
        my_reconsult('APE/dep_bumagic.pl'),
        menu1.
select_magic(_) :-
        write('Invalid choice'),
        nl,new_line,
        get_magic_choice.

my_retract(F) :-
	retract(F),
	!.
my_retract(_).

magic_prog :-
	new_line,
	write('From File: '),
	read(F1),
	new_line,
	write('To File: '),
	read(F2),
	new_line,
	write('Query: '),
	read(Q),
	magic(F1,F2,Q),
	sp_consult(F2),
	program_preds(P),
	tp_fix(P),
	menu1.
/*
clearup :-
	abolish(prove(_,_)),
	abolish(resultant(_,_)),
	abolish(resultant(_,_,_)),
	abolish(resultant(_,_,_,_)),
	abolish(cleanup(_,_,_)).
*/

% predicates td and bu used to generate standalone system for reg. approx.

a :- bu.
a :- td.

bu :-
	new_line,
	write('From File: '),
	read(F1),
	new_line,
	sp_consult(F1),
	program_preds(P),
	tp_fix(P).
	
td :-
	new_line,
	write('From File: '),
	read(F1),
	new_line,
	write('Query: '),
	read(Q),
	magic(F1,query_answer_temp_file,Q),
	sp_consult(query_answer_temp_file),
	program_preds(P),
	tp_fix(P).

imported(X) :-
	ub_clause(imported(X),true).

