/* computes the determinate unfolding rule */
/* JPG: 10.7.90 */

resultant(A,R) :-
        resultant(A,_,R).

resultant(G,P,R) :-
	ref_clause(G,B,N),
	prefix(B,P1,R),
	my_append(P1,[N],P).
	


prefix(true,[],true) :-
	!.
prefix(Gs,[(N,C)|Ns],Gs1) :-
	select_lit(Gs,B,_,N),
	selectable(B),
	!,
	expand(B,R,C),
	replace_goal(Gs,N,Gs2,B,R),
	prefix(Gs2,Ns,Gs1).
prefix(Gs,[],Gs).


selectable(B) :-
	functor(B,P,K),
	memb1(P/K, [prg/3, statement/3, asign/4, a_expr/3, 
			b_expr/3, look_up/6,
			replace_ch/4, replace/5, append/3, 
			le_test/3, eq_test/3, cond/5, andi/3, noti/2]).
selectable(B) :-
	sp_builtin(B),
	unfoldable(B).

expand(B,true,P) :-	
	sp_builtin(B),
	!,
        unfoldable(B),
	pattern(B,P),
	call(B).
expand(B,R,C) :-	
	ref_clause(B,R,C).

select_lit((G,Gs),G,Gs,1).
select_lit((B,Gs),G,(B,Gs1),N1) :-
        !,
        select_lit(Gs,G,Gs1,N),
        N1 is N+1.
select_lit(G,G,true,1).

replace_goal((G,true),2,G,_,_) :- /* eliminate true at end of goal */
	!.
replace_goal((G,Gs),1,Gs1,G,R) :-
	!,
	joingoals(R,Gs,Gs1).
replace_goal((G,Gs),N,(G,Gs1),H,R) :-
	!,
	N1 is N-1,
	replace_goal(Gs,N1,Gs1,H,R).
replace_goal(G,1,R,G,R).

