precision(P,F) :-
	precision1(P,F,N1,A),
	write('Total number of arguments: '),
	write(A),
	nl,
	write('Total arguments with known principal functor: '),
	write(N1),
	nl,
	precision2(P,F,N2),
	write('Total size of regular definitions: '),
	write(N2),
	nl.

precision1([],_,0,0).
precision1([P/J|Ps],D,N,A) :-
	\+ query_pred(P),
	\+ left_ans_pred(P),
	\+ right_ans_pred(P),
	headclause(P/J,D,Q,_),
	!,
	funcsymbols(Q,M),
	precision1(Ps,D,K,B),
	A is B+J,
	N is K+M.
precision1([_|Ps],D,N,A) :-
	precision1(Ps,D,N,A).

query_pred(P) :-
	name(P,PN),
	name('_query',QN),
	app(_,QN,PN).

left_ans_pred(P) :-
	name(P,PN),
	name('left_ans',QN),
	app(_,QN,PN).

right_ans_pred(P) :-
	name(P,PN),
	name('right_ans',QN),
	app(_,QN,PN).

funcsymbols((_ :- B),M) :-
	funcsymbs(B,M).

funcsymbs(true,0).
funcsymbs((any(_),Bs),K) :-
	!,
	funcsymbs(Bs,K).
funcsymbs((_,Bs),K) :-
	!,
	funcsymbs(Bs,K1),
	K is K1+1.
funcsymbs(any(_),0) :-
	!.
funcsymbs(_,1).

precision2([],_,0).
precision2([P/J|Ps],D,N) :-
	\+ query_pred(P),
	\+ left_ans_pred(P),
	\+ right_ans_pred(P),
	headclause(P/J,D,_,Bdefs),
	!,
	sp_length(Bdefs,M),
	precision2(Ps,D,K),
	N is K+M+1.
precision2([_|Ps],D,N) :-
	precision2(Ps,D,N).

